* FUNCTION AASCAN: Array scan by column
* ENTRY MODIFIED ON 25/10/1996 AT 14:16:59
* PARAMETERS:
*   TA_ARRAY   = Reference to array
*   TU_LOOKUP  = Value to be looked up
*   TN_COL     = Column to scan
*                By default, the first column is scanned.
*   TN_ROWS    = Last row to scan
*                By default, the whole array is scanned.
*   TN_START   = Row to start scanning from
*
* RETURN VALUE:
*   line number (or zero if not found).

PARAMETERS TA_array,TU_lookup,TN_col,TN_rows,TN_start,TU_extra
*-------------------------------------------------------------
* Equivalent of ASCAN but for a two dimensional array
* N.B. EVERY element in TA_array must either of the same type as 
*      TU_lookup or empty.
*

EXTERNAL ARRAY TA_array
PRIVATE ln_cols,ln_rows,ln_count

IF EMPTY(TN_col)
	TN_col = 1
ENDIF
LN_cols = ALEN(TA_array,2)
LN_rows = ALEN(TA_array,1)
IF LN_cols < 2
	LN_count = ASCAN(TA_array,TU_lookup)
	IF !EMPTY(TN_rows) AND TN_rows < LN_count
		RETURN 0
	ELSE
		RETURN LN_count
	ENDIF
ENDIF
DO CASE
	CASE EMPTY(TN_rows)
	CASE TN_rows < LN_rows
		LN_rows = TN_rows
ENDCASE
*
IF EMPTY(TN_start)
	LN_start = 1
ELSE
	LN_start = TN_start	
ENDIF
*
FOR LN_count = LN_start TO LN_rows
	IF !EMPTY(TA_array[LN_count,TN_col])
		IF TU_lookup = TA_array[LN_count,TN_col]
			RETURN LN_count
		ENDIF
	ELSE
		IF EMPTY(Tu_Lookup)
			IF TYPE('TU_lookup') = TYPE('TA_array[LN_count,TN_col]')
				RETURN LN_count
			ENDIF
		ENDIF
	ENDIF
ENDFOR
*
RETURN 0
