define Class MakeHash as custom
  
  * Member variables
  * ----------------
  
  cDigest         = ''
  cAlgorithmList  = ''
  cFormatTypeList = ''
  oParameter      = null
  
  * Public Interface
  * ----------------
  
  procedure Init
  *===============================================
  * Method.....: Init
  * Author.....: Mark Austen
  * Abstract...: Setup the parameters for this 
  *            : object.
  *===============================================
  lparameters ;
    poParameter
  
  declare SetHash ;
    in DECHash.dll integer nLogAction
  declare ResetHash ;
    in DECHash.dll
  declare integer GetAlgorithmList ;
    in DECHash.dll ;
      string @cBuffer
  declare integer GetAlgorithmBufferSize ;
    in DECHash.dll
  declare integer GetFormatList ;
    in DECHash.dll ;
      string @cBuffer
  declare integer GetFormatBufferSize ;
    in DECHash.dll
  declare integer SetAlgorithm ;
    in DECHash.dll ;
      string @cAlgorithm
  declare integer GetAlgorithm ;
    in DECHash.dll ;
      string @cAlgorithm
  declare integer SetFormatType ;
    in DECHash.dll ;
      string @cFormat
  declare integer SetFormatType ;
    in DECHash.dll ;
      string @cFormat
  declare integer GetDigestSize ;
    in DECHash.dll
  declare integer CalculateFile ;
    in DECHash.dll ;
      string @cFilename, ;
      string @cBuffer
  declare integer CalculateString ;
    in DECHash.dll ;
      string @cString, ;
      string @cBuffer
  *
  local ;
    lnBufferSize, ;
    lcBuffer, ;
    lcAlgorithm, ;
    lcFormat, ;
    lnDigestSize, ;
    lcFilename
 
  store ;
      '' ;
    to ;
      lcBuffer, ;
      lcAlgorithm, ;
      lcFormat, ;
      lcFilename    
  
  store ;
      0 ;
    to ;
      lnBufferSize, ;
      lnDigestSize
  
  with This
    SetHash( 0 )
    *
    lnBufferSize = GetAlgorithmBufferSize()
    lcBuffer     = space( lnBufferSize )
    
    GetAlgorithmList( @lcBuffer )
    .cAlgorithmList = lcBuffer
    
    *** Set up the formats list
    lnBufferSize = GetFormatBufferSize()
    lcBuffer     = space( lnBufferSize )
    
    GetFormatList( @lcBuffer )
    .cFormatTypeList = lcBuffer
    
    if IsObject( .oParameter )
      
      *** Set the required algorithm
      lcAlgorithm = .oParameter.cAlgorithm
      SetAlgorithm( @lcAlgorithm )

      *** Set the required format
      lcFormat = .oParameter.cFormatType
      SetFormatType( @lcFormat )
      
      .oParameter = poParameter
    endif && IsObject( .oParameter )
    
    *** Set up the correct sized buffer for the 
    *** hash result
    lnDigestSize = GetDigestSize()
    .cDigest     = space( lnDigestSize * 2 )
  endwith && This
  
  endproc && Init
 
  procedure Destroy
  *===============================================
  * Method.....: Destroy
  * Author.....: Mark Austen
  * Abstract...: Null any objects
  *===============================================
  *
  ResetHash()
  
  clear dlls ;
    SetHash, ;
    ResetHash, ;
    GetAlgorithmList, ;
    GetAlgorithmBufferSize, ;
    GetFormatList, ;
    GetFormatBufferSize, ;
    SetAlgorithm, ;
    SetFormatType, ;
    GetFormatType, ;
    GetAlgorithm, ;
    GetDigestSize, ;
    CalculateFile, ;
    CalculateString
  
  dodefault()
  
  endproc && Destroy
  *
   function ProcessFile
  *===============================================
  * Method.....: ProcessFile
  * Author.....: Mark Austen
  * Abstract...: Calculate the Hash for the 
  *            : supplied file.
  *===============================================
  
  lparameters ;
    pcFilename
  
  local ;
    lcDigest, ;
    lnHandle
 
  lcDigest = This.cDigest
  
  if not empty( pcFilename ) and ;
     file( pcFilename )
    
    *** Check to see if the file is in use
    lnHandle = fopen( pcFilename, 12 )
    
    if lnHandle # -1
      fclose( lnHandle )
      CalculateFile( @pcFilename, @lcDigest )
   endif && lnHandle # -1
   
  endif && not empty( pcFilename ) and ...
 
  return lcDigest
  
  endfunc && ProcessFile
  
enddefine && MakeHash
